#include "VCOpcodeHook.h"

#include <windows.h>
#include <stdio.h>

IOpcodeHookMgr *OpcodeHookMgr;

/* PutPlayerAtHook:
	Example showing a query to the put_player_at opcode. */
bool __cdecl PutPlayerAtHook(unsigned int varPtr, float x, float y, float z)
{
	char msg[50];
	sprintf(msg, "Put player at: %0.3f %0.3f %0.3f", x, y, z);
	MessageBox(0, msg, "SCM Info!", MB_OK);

	/*	The return value of a handler is the compare flag for the scm.
		If you don't plan on updating the compare flag then it doesn't matter
		what you return. */
	return false;
}

/* CreateHook:
	This function will be called by VCOpcodeHook.asi; passing the
	OpcodeHookMgr pointer. */
bool __stdcall CreateHook(IOpcodeHookMgr *pOpcodeHookMgr)
{
	/* Save OpcodeHookMgr pointer for later use. */
	OpcodeHookMgr = pOpcodeHookMgr;

	/* Add opcode hook for querying put_player_at opcode. */
	if ( OpcodeHookMgr->add(0x0055, 4, false, false, &PutPlayerAtHook) )
		return true;

	return false;
}